local encounters = HudMap:GetModule("Encounters")
encounters:RegisterEvent("PLAYER_REGEN_ENABLED", "Yell")
local HudMap = HudMap
local L = LibStub("AceLocale-3.0"):GetLocale("HudMap")
local free = HudMap.free
local SearingSeedMarkers = {}
local SearingSeedSpell = GetSpellInfo(98450)


local function register(e)	
	encounters:RegisterEncounterMarker(e)
	return e
end

local function checkwipe()
	local flag = true
	SetMapToCurrentZone()
	
	
	for i=1, 40 do
		local unit = "raid" .. i
		if UnitIsVisible(unit) and UnitAffectingCombat(unit) then
			flag = false
			break
		end
	end
	
	return flag
end

local FandralStaghelm = {
	name = L["FandralStaghelm"],
	startEncounterIDs = 52571,
	endEncounterIDs = 52571,
	timerUpdateFrame = CreateFrame("frame"),
	---[[
	options = {
		SearingSeed = GetSpellInfo(98450),
	},
	defaults = {
		SearingSeed = false,
		SearingSeedColor = {r = 1, g = 0, b = 0, a = 0.5},
	},
	Start = function(self)
		HudMap:Toggle(true)
	end,
	PLAYER_REGEN_ENABLED = function(self)
		encounters:FreeEncounterMarkers()
		wipe(SearingSeedMarkers)
	end,
	SPELL_AURA_APPLIED = function(self, spellID, sourceName, destName, sourceGUID, destGUID)		
		if spellID == 98450 and self:Option("SearingSeedEnabled") then
			local _, _, _, _, _, duration, expires, _, _ = UnitDebuff("player", SearingSeedSpell)
			expires = expires -6
			
			
			SearingSeedMarkers[destName] = SearingSeedMarkers[destName] or {}
			SearingSeedMarkers[destName].time = expires
			self.timerUpdateFrame:Show()
			--register(HudMap:PlaceRangeMarkerOnPartyMember("highlight", destName, 12, 6, r, g, b, a):SetLabel(destName))
		end	
			
	end,	
	SPELL_AURA_REMOVED = function(self, spellID, sourceName, destName, sourceGUID, destGUID)
		if spellID == 98450 and self:Option("SearingSeedEnabled") and SearingSeedMarkers[destName] then
			if SearingSeedMarkers[destName].mark then
				SearingSeedMarkers[destName].mark = free(SearingSeedMarkers[destName].mark)
			end
			wipe(SearingSeedMarkers[destName])
			SearingSeedMarkers[destName] = nil
			
			if not next(SearingSeedMarkers) then
				self.timerUpdateFrame:Hide()
			end
		end
	end,	
}


local function OnUpdate()
	local t = GetTime()
	for name, info in pairs(SearingSeedMarkers) do
		if info.time and info.time < t then
			info.time = nil
			local r,g,b,a = FandralStaghelm:Option("SearingSeedColor")
			info.mark = register(HudMap:PlaceRangeMarkerOnPartyMember("highlight", name, 12, 6, r, g, b, a):SetLabel(name))
		end
	end	
end

FandralStaghelm.timerUpdateFrame:SetScript("OnUpdate",OnUpdate)
FandralStaghelm.timerUpdateFrame:Hide()

encounters:RegisterModule(L["FireLand"], FandralStaghelm)
