local timer = LibStub("AceTimer-3.0")
local encounters = HudMap:GetModule("Encounters")
encounters:RegisterEvent("UNIT_SPELLCAST_SUCCEEDED", "Yell")  -- the method is named Yell, wired but can be used to all events. Defined is in Addons/HudMap/modules/encounters.lua
encounters:RegisterEvent("PLAYER_REGEN_ENABLED", "Yell")
local seedsActive


local HudMap = HudMap
local L = LibStub("AceLocale-3.0"):GetLocale("HudMap")
local free = HudMap.free


local function register(e)	
	encounters:RegisterEncounterMarker(e)
	return e
end

local function checkwipe()
	local flag = true
	SetMapToCurrentZone()
	
	
	for i=1, 40 do
		local unit = "raid" .. i
		if UnitIsVisible(unit) and UnitAffectingCombat(unit) then
			flag = false
			break
		end
	end
	
	return flag
end


local Ragnaros = {
	name = L["Ragnaros"],
	startEncounterIDs = 52409,--, --!!
	endEncounterIDs = 52409,--,
	---[[
	options = {
		MoltenSeed = GetSpellInfo(100386),
	},
	defaults = {
		MoltenSeed = true,
		MoltenSeedColor = {r = 1, g = 0, b = 0, a = 0.5},
	},
	Start = function(self)
		HudMap:Toggle(true)
	end,
	PLAYER_REGEN_ENABLED = function(self)
		encounters:FreeEncounterMarkers()
	end,
	UNIT_SPELLCAST_SUCCEEDED = function(self,unit,spellName)		
		if spellName == GetSpellInfo(100386) and not seedsActive and self:Option("MoltenSeedEnabled") then
			seedsActive = true
			encounters:Delay(function()seedsActive = false end, 17.5)
			local r,g,b,a = self:Option("MoltenSeedColor")
			for i=1, 40 do
				local unit = "raid" .. i
				if UnitIsVisible(unit) and not UnitIsDeadOrGhost(unit) then
					register(HudMap:PlaceStaticMarkerOnPartyMember("highlight", unit, 6, 10,r,g,b,a):Appear():RegisterForAlerts():SetAlertColor(0,1,0,0.5))
				end
			end
		end					
	end,
}

encounters:RegisterModule(L["FireLand"], Ragnaros)