local timer = LibStub("AceTimer-3.0")
local encounters = HudMap:GetModule("Encounters")
encounters:RegisterEvent("PLAYER_REGEN_ENABLED", "Yell")
local HudMap = HudMap
local L = LibStub("AceLocale-3.0"):GetLocale("HudMap")
local free = HudMap.free


local function register(e)	
	encounters:RegisterEncounterMarker(e)
	return e
end


local trapScansDone = 0
local timerHandle
local Traps = {}

local function PlaceTrapMarker(x, y, r, g, b, a, TrapGUID)
	if Traps[TrapGUID] then return end
	local marker = register(HudMap:PlaceRangeMarker("highlight", x, y, 5, nil, r, b, g, a))
	Traps[TrapGUID] = marker
end

local function CancelTrap(TrapGUID)
	local trap = Traps[TrapGUID]
	if trap then
		free(trap)
		Traps[TrapGUID] = nil
	end	
end

local function TrapHandler(args)
	local self, SpellID, isTank, TrapGUID = unpack(args)
	trapScansDone = trapScansDone + 1
	if UnitExists("boss1target") then--Better way to check if target exists and prevent nil errors at same time, without stopping scans from starting still. so even if target is nil, we stil do more checks instead of just blowing off a trap warning.
		local targetname = UnitName("boss1target")
		if UnitDetailedThreatSituation("boss1target", "boss1") and not isTank then--He's targeting his highest threat target.
			if trapScansDone < 12 then--Make sure no infinite loop.
				timerHandle = timer:ScheduleTimer(TrapHandler, 0.05, {self, SpellID, nil, TrapGUID})--Check multiple times to be sure it's not on something other then tank.
			else
				TrapHandler({self, SpellID, true, TrapGUID})--It's still on tank, force true isTank and activate else rule and warn trap is on tank.
			end
		else--He's not targeting highest threat target (or isTank was set to true after 12 scans) so this has to be right target.
			timer:CancelTimer(timerHandle,true)--Unschedule all checks just to be sure none are running, we are done.
			if SpellID == 99836 then -- CrystalTrap
				local x,y = HudMap:GetUnitPosition("boss1target")
				local r,g,b,a = self:Option("CrystalPrisonTrapColor")
				PlaceTrapMarker(x, y, r, g, b, a, TrapGUID)
			elseif SpellID == 99839 then-- ImmoTrap
				local x,y = HudMap:GetUnitPosition("boss1target")
				local r,g,b,a = self:Option("ImmoTrapColor")
				PlaceTrapMarker(x, y, r, g, b, a, TrapGUID)
			end
		end
	else--target was nil, lets schedule a rescan here too.
		if trapScansDone < 12 then--Make sure not to infinite loop here as well.
			timerHandle = timer:ScheduleTimer(TrapHandler, 0.05, {self, SpellID, nil, TrapGUID})
		end
	end
end

local function checkwipe()
	local flag = true
	SetMapToCurrentZone()
	
	
	for i=1, 40 do
		local unit = "raid" .. i
		if UnitIsVisible(unit) and UnitAffectingCombat(unit) then
			flag = false
			break
		end
	end
	
	return flag
end
			



local Shannox = {
	name = L["Shannox"],
	startEncounterIDs = 53691,
	endEncounterIDs = 53691,
	---[[
	options = {
		ImmoTrap = L["ImmoTrap"],
		CrystalPrisonTrap = L["CrystalPrisonTrap"],
	},
	defaults = {
		ImmoTrap = true,
		ImmoTrapColor = {r = 1, g = 0, b = 0, a = 0.5},
		CrystalPrisonTrap = true,
		CrystalPrisonTrapColor = {r = 0, g = 0, b = 1, a = 0.5},-- here
	},
	Start = function(self)
		HudMap:Toggle(true)
	end,
	SPELL_SUMMON = function(self, spellID, sourceName, destName, sourceGUID, destGUID)
		--if self:Option("ImmoTrapEnabled") or self:Option("CrystalPrisonTrapEnabled") then
		if spellID == 99836 and self:Option("CrystalPrisonTrapEnabled") then
			trapScansDone = 0
			TrapHandler({self, spellID, nil, destGUID})
		elseif spellID == 99839 and  self:Option("ImmoTrapEnabled") then
			trapScansDone = 0
			TrapHandler({self, spellID, nil, destGUID})
		end
	end,
	PLAYER_REGEN_ENABLED = function(self)
		encounters:FreeEncounterMarkers()
		wipe(Traps)
	end,
	SPELL_AURA_APPLIED = function(self, spellID, sourceName, destName, sourceGUID, destGUID)
		if spellID == 99837 or spellID == 101210 then
			if self:Option("ImmoTrapEnabled") or self:Option("CrystalPrisonTrapEnabled") then
					CancelTrap(sourceGUID)
			end
		end
	end,		
}

encounters:RegisterModule(L["FireLand"], Shannox)
